# Class ConstantPackage

java.lang.Object
org.apache.bcel.classfile.Constant
org.apache.bcel.classfile.ConstantPackage

All Implemented Interfaces:
  `Cloneable, ConstantObject, Node`

public final class ConstantPackage extends Constant implements ConstantObject
This class is derived from the abstract `Constant` and represents a reference to a package.

Note: Early access Java 9 support- currently subject to change

Since:
  6.1
See Also:
  - `Constant`

- ## Field Summary

  ### Fields inherited from class Constant

  `tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ConstantPackage(int nameIndex)`
  `ConstantPackage(ConstantPackage c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `void`
  `dump(DataOutputStream file)`
  Dump constant package to file stream in binary format.
  `String`
  `getBytes(ConstantPool cp)`
  `Object`
  `getConstantValue(ConstantPool cp)`
  Gets the object representing the constant, for example, Long for ConstantLong.
  `int`
  `getNameIndex()`
  `void`
  `setNameIndex(int nameIndex)`
  `String`
  `toString()`

  ### Methods inherited from class Constant

  `clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ConstantPackage

    public ConstantPackage(ConstantPackage c)
    Initialize from another object.
    Parameters:
      `c` - Source to copy.

  - ### ConstantPackage

    public ConstantPackage(int nameIndex)
    Parameters:
      `nameIndex` - Name index in constant pool. Should refer to a ConstantUtf8.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Constant`
    Parameters:
      `v` - Visitor object

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump constant package to file stream in binary format.
    Specified by:
      `dump` in class `Constant`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getBytes

    public String getBytes(ConstantPool cp)
    Returns:
      dereferenced string

  - ### getConstantValue

    public Object getConstantValue(ConstantPool cp)
    Description copied from interface: `ConstantObject`
    Gets the object representing the constant, for example, Long for ConstantLong.
    Specified by:
      `getConstantValue` in interface `ConstantObject`
    Parameters:
      `cp` - the constant.
    Returns:
      String object

  - ### getNameIndex

    public int getNameIndex()
    Returns:
      Name index in constant pool of package name.

  - ### setNameIndex

    public void setNameIndex(int nameIndex)
    Parameters:
      `nameIndex` - the name index in the constant pool of this Constant Package

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Constant`
    Returns:
      String representation.